<link rel="import" href="../bower_components/app-layout/app-toolbar/app-toolbar.html">
<link rel="import" href="../bower_components/paper-icon-button/paper-icon-button.html">
<link rel="import" href="../bower_components/app-layout/app-drawer/app-drawer.html">
<link rel="import" href="../bower_components/neon-animation/neon-animation.html">

<link rel="import" href="sc-controls/sc-controls.html">
<link rel="import" href="sc-schema/sc-schema.html">
<link rel="import" href="dez-label-editor/dez-label-editor.html">
<link rel="import" href="sc-score/sc-score.html">
<link rel="import" href="sc-debug/sc-debug.html">
<link rel="import" href="sc-pieces/sc-pieces.html">

<dom-module id="sc-view">
  <template>
  <style>
    :host {
      --app-primary-color: #4285f4;
      --app-secondary-color: black;

      display: block;
    }

    html, body {
      margin: 0;
      font-family: 'Roboto', 'Noto', sans-serif;
      -webkit-font-smoothing: antialiased;
      background: #f1f1f1;
      max-height: 368px;
    }
    app-toolbar {
      background-color: #607D8B;
      color: #fff;
    }
    app-drawer {
      z-index: 10;
      --app-drawer-scrim-background: rgba(0, 0, 100, 0.8);
      --app-drawer-content-container: {
        background-color: #909EA5;
        color: #eee;
        padding-left: 15px;
        padding-right: 15px;
        min-width: 350px;
      }
    }

    #material-scrollable, #clone { background-color: white; }

    span.composer { font-size: smaller; margin-left: 1ex; }
  </style>

  <paper-dialog id="splash" entry-animation="scale-up-animation" exit-animation="fade-out-animation" with-backdrop>
  </paper-dialog>


      <iron-ajax
          auto
          id = "requestInfo"
          url = "[[server]]/corpus/[[id]]"
          handle-as = "json"
          on-response = "updateInfo"
          debounce-duration="300"
         >
     </iron-ajax>
     <iron-ajax
         auto
         id = "splashContent"
         url = "../about.html"
         handle-as = "text"
         on-response = "displaySplash"
         debounce-duration="300"
        >
    </iron-ajax>
    <app-toolbar>
        <paper-icon-button icon="menu" title="load piece" on-tap="toggleDrawer"></paper-icon-button>
        <div main-title>[[name]] <span class='composer'>[[composer]]</span></div>
        <sc-controls id="controls" target="myscore" url="[[server]]/corpus/{{id}}/analyses/"></sc-controls>
    </app-toolbar>
    <app-drawer id="drawer" swipe-open on-tap="_closeDrawer">
        <sc-pieces id="piecesMenu" url="[[server]]/corpus" piece-id="{{id}}"></sc-pieces>
    </app-drawer>
    <sc-schema id="schema">
    </sc-schema>
    <div id="material-scrollable" style="overflow-x: scroll;">
        <sc-score
        id="myscore"
        bg="{{bg}}"
        positions="[[server]]/corpus/{{id}}/positions"
        ratio="0.7"></sc-score>
    </div>
    <div id="clone" style="text-align:center; padding-top: 10px;">
    <sc-score
        id="myscoreclone"
        bg="{{bg}}"
        positions="[[server]]/corpus/[[id]]/positions"
        bg-height="60">
    </sc-score>
    </div>
    <dez-label-editor id="label-editor" target="myscore"></dez-label-editor>
    <template is="dom-if" if={{_isDebugMode}}>
        <sc-debug></sc-debug>
    </template>
  </template>

  <script>
    Polymer({
        is: 'sc-view',

        properties: {
            id: {
                type: String,
                observer: '_onIdChanged'
            },
            server: String,
            bg: String
        },

        toggleDrawer: function() {
          this.$.drawer.toggle();
          this.$.piecesMenu.generateList()
        },

        ready: function () {
            this._isDebugMode = (this.baseURI.split("?mode=")[1] == "debug");
            this.$.controls.schema = this.$.schema;
        },

        _closeDrawer: function () {
            this.$.drawer.close();
        },

        _onIdChanged: function () {
            if (!this.$.drawer.persistent) {
                this.$.drawer.close();
            }
            this.bg = "../corpus/" + this.id + "/" + this.id + ".png"
        },

        getInfo: function (data) {
            this.name = data.detail.response['title']
            this.composer = data.detail.response['composer']
        },

        updateInfo: function (data) {
            this.getInfo(data)
            document.title = this.name + ", " + this.composer + " - Dezrann"
        },

        displaySplash: function(data) {
            var response = data.detail.response
            this.$.splash.innerHTML += response
                + '<div id="buttons" class="buttons">'
                + '<paper-button dialog-confirm autofocus>OK</paper-button>'
                + '</div>'
            this.$.splash.open();
        },

    });
  </script>
</dom-module>
